package cz.davidkabelka.myapplication;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import android.Manifest;
import android.app.job.JobInfo;
import android.app.job.JobScheduler;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.icu.util.Calendar;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.PersistableBundle;
import android.text.Editable;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity implements AsyncResponse, LocationListener{


    String url = "http://zebramapruhy.asuscomm.com:8086/query?u=telefon&p=telefon_heslo&db=gps_data&q=SELECT%20LAST(latitude),lontitude%20FROM%20gps_poz";

    String buttonURL = "https://www.google.com/search";

    int hranice = 200;

    LocationManager mLocationManager;

    public Criteria criteria;
    public String bestProvider;


    MyAsyncTask asyncTask = new MyAsyncTask();




    Button nastavHranici;
    EditText textHranice ;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        //this to set delegate/listener back to this class

        nastavHranici = (Button)findViewById(R.id.buttonNastavHranici);
        textHranice = (EditText)findViewById(R.id.metryInput);

        nastavHranici.setOnClickListener(
                new View.OnClickListener()
                {
                    public void onClick(View view)
                    {
                        hranice = Integer.parseInt(textHranice.getText().toString());
                        Log.v("EditText", textHranice.getText().toString());
                        cancelJob();
                        scheduleJob();
                    }
                });

        scheduleJob();

        asyncTask.delegate = this;

        //execute the async task
        asyncTask.execute();

    }





    public void processFinish(String output) {
        //Here you will receive the result fired from async class
        //of onPostExecute(result) method.
        double[] LatLon = poloha();

        Log.e("ERR_MainAct vysledekDoublu", LatLon[0] + " and " +LatLon[1]);

        String[] latlong = output.split(",");

        double DBlatitude = Double.parseDouble(latlong[1]);
        double DBlongitude = Double.parseDouble(latlong[2]);

        double latitude = LatLon[0];
        double longtitude = LatLon[1];

        TextView textView = (TextView) findViewById(R.id.tv);
        textView.setText("Pozice vozidla: " + String.valueOf(DBlatitude) + ", " + String.valueOf(DBlongitude) + "\r\nPozice telefonu: " + String.valueOf(latitude) + ", " + String.valueOf(longtitude));

        Log.e("ERR_MainAct prehled pozic", "DB " + String.valueOf(DBlatitude)+"  "+String.valueOf(DBlongitude) + "Foun "+String.valueOf(latitude) +"  "+ String.valueOf(longtitude));
        Log.e("ERR_MainAct vzdalenost", distance(DBlatitude, latitude, DBlongitude, longtitude) + " metru");

        buttonURL = "https://www.google.com/search?q="+ latlong[1] +"+"+latlong[2];


    }



    public void otevriProhlizec(View view) {
        Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(buttonURL));
        startActivity(browserIntent);

    }


    public double[] poloha(){
        double[] LatLon= new double[2];


        mLocationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        criteria = new Criteria();
        bestProvider = String.valueOf(mLocationManager.getBestProvider(criteria, true)).toString();

        if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            // TODO: Consider calling
            //    ActivityCompat#requestPermissions
            // here to request the missing permissions, and then overriding
            //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
            //                                          int[] grantResults)
            // to handle the case where the user grants the permission. See the documentation
            // for ActivityCompat#requestPermissions for more details.
            Log.e("ERR_MainAct", " Chybí oprávnění ");


            return LatLon;
        }
        Location location = mLocationManager.getLastKnownLocation(bestProvider);
        if (location != null) {
            // Do something with the recent location fix
            //  otherwise wait for the update below
            Log.e("ERR_MainAct", " Poloha nalezena ");

        } else {
            mLocationManager.requestLocationUpdates(bestProvider, 1000, 0, this);

            Log.e("ERR_MainAct", " Poloha nenalezena ");
        }

        LatLon[0] = round(location.getLatitude(),6);
        LatLon[1] = round(location.getLongitude(),6);


        return LatLon;
    }

    public static double round(double value, int places) {
        if (places < 0) throw new IllegalArgumentException();

        long factor = (long) Math.pow(10, places);
        value = value * factor;
        long tmp = Math.round(value);
        return (double) tmp / factor;
    }

    public static double distance(double lat1, double lat2, double lon1,
                                  double lon2) {

        final int R = 6371; // Radius of the earth

        double latDistance = Math.toRadians(lat2 - lat1);
        double lonDistance = Math.toRadians(lon2 - lon1);
        double a = Math.sin(latDistance / 2) * Math.sin(latDistance / 2)
                + Math.cos(Math.toRadians(lat1)) * Math.cos(Math.toRadians(lat2))
                * Math.sin(lonDistance / 2) * Math.sin(lonDistance / 2);
        double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
        double distance = R * c * 1000; // convert to meters



        distance = Math.pow(distance, 2);

        return Math.sqrt(distance);
    }



    private void scheduleJob(){
        JobScheduler jobScheduler = (JobScheduler)getApplicationContext()
                .getSystemService(JOB_SCHEDULER_SERVICE);

        ComponentName componentName = new ComponentName(this,
                DbUpdateJobService.class);

        PersistableBundle bundle = new PersistableBundle();
        bundle.putInt("hranice",hranice);

        JobInfo jobInfo = new JobInfo.Builder(1, componentName)
                .setPeriodic(1000*15*60).setRequiredNetworkType(
                        JobInfo.NETWORK_TYPE_NOT_ROAMING)
                .setPersisted(true)
                .setExtras(bundle)

                .build();
        jobScheduler.schedule(jobInfo);
        Log.e("ERR_MainAct", "Aktivace Jobu");
    }


    public void cancelJob() {
        JobScheduler scheduler = (JobScheduler) getSystemService(JOB_SCHEDULER_SERVICE);
        scheduler.cancel(1);
        Log.e("ERR_MainAct", "Job cancelled");
    }



    @Override
    public void onLocationChanged(Location location) {
        if (location != null) {
            Log.e("ERR_MainAct Location Changed", location.getLatitude() + " and " + location.getLongitude());
            mLocationManager.removeUpdates(this);
        }
    }

    @Override
    public void onStatusChanged(String s, int i, Bundle bundle) {

    }

    @Override
    public void onProviderEnabled(String s) {

    }

    @Override
    public void onProviderDisabled(String s) {

    }

}