package cz.davidkabelka.myapplication;

import android.os.AsyncTask;

import com.google.gson.Gson;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;

public class MyAsyncTask extends AsyncTask<String, Void, String> {
    public AsyncResponse delegate = null;
    String server_response = "";

    @Override
    protected String doInBackground(String... strings) {
        URL url;
        HttpURLConnection urlConnection = null;


        try {
            url = new URL("http://zebramapruhy.asuscomm.com:8086/query?u=telefon&p=telefon_heslo&db=gps_data&q=SELECT%20latitude,lontitude%20FROM%20gps_poz%20GROUP%20BY%20*%20ORDER%20BY%20DESC%20LIMIT%201");
            urlConnection = (HttpURLConnection) url.openConnection();

            int responseCode = urlConnection.getResponseCode();


            if(responseCode == HttpURLConnection.HTTP_OK){
                server_response = readStream(urlConnection.getInputStream());
                //Log.v("CatalogClient", server_response);
            }

        } catch (MalformedURLException e) {

            e.printStackTrace();
        } catch (IOException e) {

            e.printStackTrace();
        }

        return null;
    }

    // Converting InputStream to String

    private String readStream(InputStream in) {
        BufferedReader reader = null;
        StringBuffer response = new StringBuffer();
        try {
            reader = new BufferedReader(new InputStreamReader(in));
            String line = "";
            while ((line = reader.readLine()) != null) {
                response.append(line);
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (reader != null) {
                try {
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }


        Gson gson = new Gson();
        Databaze dtb = gson.fromJson(response.toString(), Databaze.class);



        List<Result> re = dtb.results;
        Result r = re.get(0);
        List<Series> s = r.series;
        Series se = s.get(0);
        List<List<String>> li = se.values;
        List<String> vals = li.get(0);

        String datum = vals.get(0);
        String gps1 = vals.get(1);
        String gps2 = vals.get(2);


        String out = datum + "," + gps1 + "," + gps2;


        return out;
    }

    @Override
    protected void onPostExecute(String result) {
        delegate.processFinish(server_response);

    }
}